# -*- mode: yaml; -*-

# Copyright 2019 Clara Andrew-Wani <candrew@wikimedia.org>, Eric Evans <eevans@wikimedia.org>,
# and Wikimedia Foundation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# The name of this service (as it appears in logs)
service_name: kask

# A constant prepended to all URIs; Everything that appears after is
# parsed as the key
base_uri: /sessions/v1

# The IP interface and port to bind the service to
listen_address: localhost
listen_port: 8081

# A time-to-live (in seconds) for stored values (0 disables)
default_ttl: 86400

# Log level, one of (in increasing severity): debug, info, warning, error and fatal
log_level: info

# Complete path to an OpenAPI specification (optional).  The file specified is
# expected to be in OpenAPI YAML format (see https://swagger.io/specification),
# and will be served from /openapi (i.e. http://localhost:8081/openapi).
openapi_spec: /etc/kask/openapi.yaml

# Kask server encryption (optional)
# NOTE: If the certificate is signed by an authority, then the file specified
# here should be a concatenation of both the server and authority certificates.
tls:
  cert: /etc/kask/cert.pem
  key: /etc/kask/key.pem

# Cassandra connection information
cassandra:
  hosts:
    - 172.17.0.2
    - 172.17.0.3
    - 172.17.0.4
  port:     9042
  keyspace: kask
  table:    values
  # The data-center local to this endpoint
  local_dc: datacenter1
  # Cassandra query timeout in milliseconds (defaults to 12000)
  query_timeout_ms: 12000
  # Cassandra connection timeout in milliseconds (defaults to 5000)
  connect_timeout_ms: 5000
  # Password authentication (optional)
  authentication:
    username: jsmith
    password: supersecret
  # Cassandra client encryption (optional)
  tls:
    # Full path to the certificate authority
    ca: /etc/cassandra/tls/ca.pem
    # Values for cert and key may be omitted if certifcation verification
    # is not required.  However, if either is provided, both must be.
    cert: /etc/cassandra/tls/cert.pem
    key: /etc/cassandra/tls/key.pem
    # Verify the server's certification chain and hostname (defaults to true).
    enable_host_verification: true
